Subject: Re: [Gen-art] Gen-ART Last Call review of draft-ietf-dnsop-qname-minimisation-07

From: "Ralph Droms (rdroms)" <[email-masked]>
Date: Tue, 1 Dec 2015 13:55:46 +0000

> On Nov 26, 2015, at 7:41 AM 11/26/15, Stephane Bortzmeyer <[email-masked]> wrote:
> 
> On Fri, Nov 20, 2015 at 04:22:21PM +0000,
> Ralph Droms (rdroms) <[email-masked]> wrote
> a message of 97 lines which said:
> 
>> I am the assigned Gen-ART reviewer for
>> draft-ietf-dnsop-qname-minimisation-07.txt.
> 
> Hello. Glad to have reviewers.

This document is well-written and easy to read.  It's a pleasure to do the review.

> 
>> Has the working group considered publishing this document as
>> "Informational" rather than "Experimental"?  If the document is
>> published as "Experimental", is the intention to publish a
>> subsequent proposed standard or BCP?
> 
> [See Tim's answer.]

OK.

> 
>> I found the descriptions in the document understandable, but not
>> quite detailed enough to build an interoperable implementation.
> 
> There is something very important about qname minimisation: it is a
> local technique, not a protocol. It works with unmodified authoritative
> name servers. So "interoperability" is not a concern because it does
> not change the DNS protocol. Consequence: each resolver MAY implement
> it slightly differently (see appendix B).

OK, I understand this is a local technique and does not represent a change to the DNS protocols.  Even so, in my opinion there are some details that are not provided in the document (see below).

>> Is Appendix A intended as the specification for the QNAME
>> minimization techniques described in this document?
> 
> No. That's why it's in an appendix. Most resolvers already can find
> the zone cuts (they need it to do DNSSEC), this appendix is to give
> ideas to developers of the other resolvers.

Would you consider adding a little text somewhere to make it clear that the Appendix is intended as a guide to implementors?

>> The appendix is titled "An algorithm to find the zone cut" and the
>> introductory text indicates the algorithm is intended for locating
>> the zone cut.  However, as I read the algorithm, it finds and
>> traverses all zone cuts until the original QNAME can be resolved.
> 
> The title may be misleading. What about "An algorithm to perform QNAME
> minimisation in presence of zone cuts?"

Perhaps "unknown zone cuts"?  Otherwise, that title sounds good.

My recommendation to improve the document would be the inclusion of another appendix, describing the algorithm to use if zone cuts are known.  In my opinion, what's missing from the document for an inexperienced implementor is a summary of how to build the resolver you refer to in section 2: "The minimising resolver works perfectly when it knows the zone cut"

>> In section 2, is the phrase "closest known parent of the original
>> QNAME" something that most DNS developers would understand?
> 
> Well, "parent" could be misleading because it is rather "ancestor"
> (the example in the draft show a grand-parent).
> 
>> Would the phrase "closest enclosing NS RRset" from Appendix A be
>> more precise?
> 
> "Known" is very important here. What about "closest known enclosing NS
> RRset"?

OK, that text would be good.

>> I wasn't sure at first whether "(section 6)" in the 4th paragraph of
>> section 2 referred to section 6 of RFC 2181 or section 6 of this
>> document.
> 
> OK, fixed in my local copy.

Great.

> 
> 
> _______________________________________________
> Gen-art mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/gen-art

---

From: Stephane Bortzmeyer <[email-masked]>
Date: Mon, 7 Dec 2015 19:31:14 +0100

On Tue, Dec 01, 2015 at 01:55:46PM +0000,
 Ralph Droms (rdroms) <[email-masked]> wrote 
 a message of 128 lines which said:

> Would you consider adding a little text somewhere to make it clear
> that the Appendix is intended as a guide to implementors?

Done,
<https://github.com/bortzmeyer/my-IETF-work/commit/b768c43ab0624ec9cc8361d221a27058b64b19a2>

> My recommendation to improve the document would be the inclusion of
> another appendix, describing the algorithm to use if zone cuts are
> known.

It already exists, this is the second paragraph of section 2. (The
ideal case.)

But I do not find useful to add more text: for a real resolver, the
algorithm in appendix A suffices (it works if the zone cuts are known,
see step 1).

---

From: "Ralph Droms (rdroms)" <[email-masked]>
Date: Wed, 16 Dec 2015 23:54:48 +0000

> On Dec 7, 2015, at 1:31 PM 12/7/15, Stephane Bortzmeyer <[email-masked]> wrote:
> 

For the inexperienced implementor, a little more detail might be useful.

---

From: Jari Arkko <[email-masked]>
Date: Thu, 17 Dec 2015 15:13:46 +0200

Ralph, Stephane,

I have no strong opinion on Exp/Inf, although I do sympathise with some of the points Ralph is making. Are the change that you are discussing in your opinion sufficient, or do we need further discussion?

jari